from gnuviechadmin_services import *
from ZSI.ServiceContainer import ServiceSOAPBinding

class gnuviechadmin(ServiceSOAPBinding):
    soapAction = {
        'https://ssl.gnuviech.info/gnuviechadmin/Authenticate': 'soap_Authenticate',
        'https://ssl.gnuviech.info/gnuviechadmin/ListDomains': 'soap_ListDomains',
        'https://ssl.gnuviech.info/gnuviechadmin/ListMailAliases': 'soap_ListMailAliases',
        }
    _wsdl = """<?xml version=\"1.0\" ?>
<!-- 
	Webservice description for gnuviechadmin
	(c) 2006 Jan Dittberner <jan@dittberner.info>
	Version: $Id: gnuviechadmin.wsdl 862 2006-03-07 15:02:39Z jan $
--><wsdl:definitions name=\"gnuviechadmin\" targetNamespace=\"https://ssl.gnuviech.info/gnuviechadmin/\" xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\" xmlns:tns=\"https://ssl.gnuviech.info/gnuviechadmin/\" xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">
	<wsdl:types>
		<xsd:schema targetNamespace=\"https://ssl.gnuviech.info/gnuviechadmin/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">
			<xsd:element name=\"AuthCode\" type=\"xsd:string\"/>
			<xsd:element name=\"LoginInfo\" type=\"tns:LoginInfo\"/>
			<xsd:complexType name=\"LoginInfo\">
				<xsd:sequence maxOccurs=\"1\" minOccurs=\"1\">
					<xsd:element name=\"login\" type=\"xsd:string\"/>
					<xsd:element name=\"password\" type=\"xsd:string\"/>
				</xsd:sequence>
			</xsd:complexType>
			<xsd:element name=\"DomainList\" type=\"tns:DomainList\"/>
			<xsd:complexType name=\"DomainList\">
				<xsd:sequence maxOccurs=\"unbounded\" minOccurs=\"0\">
					<xsd:element name=\"domain\" type=\"tns:Domain\"/>

				</xsd:sequence>
			</xsd:complexType>
			<xsd:element name=\"ListMailAliasesResponse\" type=\"tns:MailAliasList\"/>
			<xsd:element name=\"ListMailAliasesRequest\">
				<xsd:complexType>
					<xsd:sequence maxOccurs=\"1\" minOccurs=\"1\">
						<xsd:element name=\"AuthCode\" type=\"xsd:string\"/>
						<xsd:element name=\"DomainName\" type=\"xsd:string\"/>
					</xsd:sequence>
				</xsd:complexType>
			</xsd:element>
			<xsd:complexType name=\"Domain\">
				<xsd:sequence maxOccurs=\"1\" minOccurs=\"1\">
					<xsd:element name=\"domainName\" type=\"xsd:string\"/>
				</xsd:sequence>
			</xsd:complexType>
			<xsd:complexType name=\"MailAlias\">
				<xsd:sequence maxOccurs=\"1\" minOccurs=\"1\">
					<xsd:element name=\"alias\" type=\"xsd:string\"/>
					<xsd:element name=\"target\" type=\"xsd:string\"/>
				</xsd:sequence>
			</xsd:complexType>

			<xsd:complexType name=\"MailAliasList\">
				<xsd:sequence maxOccurs=\"unbounded\" minOccurs=\"0\">
					<xsd:element name=\"alias\" type=\"tns:MailAlias\"/>

				</xsd:sequence>
			</xsd:complexType>

		</xsd:schema>
	</wsdl:types>
	<wsdl:message name=\"AuthResponse\">
		<wsdl:part element=\"tns:AuthCode\" name=\"AuthResponse\"/>
	</wsdl:message>
	<wsdl:message name=\"AuthRequest\">
		<wsdl:part element=\"tns:LoginInfo\" name=\"AuthRequest\"/>
	</wsdl:message>
	<wsdl:message name=\"ListDomainsResponse\">
		<wsdl:part element=\"tns:DomainList\" name=\"ListDomainsResponse\"/>
	</wsdl:message>
	<wsdl:message name=\"ListDomainsRequest\">
		<wsdl:part element=\"tns:AuthCode\" name=\"ListDomainsRequest\"/>
	</wsdl:message>
	<wsdl:message name=\"ListMailAliasesResponse\">
		<wsdl:part element=\"tns:ListMailAliasesResponse\" name=\"ListMailAliasesResponse\"/>

	</wsdl:message>
	<wsdl:message name=\"ListMailAliasesRequest\">
		<wsdl:part element=\"tns:ListMailAliasesRequest\" name=\"ListMailAliasesRequest\"/>

	</wsdl:message>
	<wsdl:portType name=\"gnuviechadmin\">
		<wsdl:operation name=\"Authenticate\">
			<wsdl:input message=\"tns:AuthRequest\"/>
			<wsdl:output message=\"tns:AuthResponse\"/>
		</wsdl:operation>
		<wsdl:operation name=\"ListDomains\">
			<wsdl:input message=\"tns:ListDomainsRequest\"/>
			<wsdl:output message=\"tns:ListDomainsResponse\"/>
		</wsdl:operation>
		<wsdl:operation name=\"ListMailAliases\">
			<wsdl:input message=\"tns:ListMailAliasesRequest\"/>
			<wsdl:output message=\"tns:ListMailAliasesResponse\"/>
		</wsdl:operation>
	</wsdl:portType>
	<wsdl:binding name=\"gnuviechadminSOAP\" type=\"tns:gnuviechadmin\">
		<soap:binding style=\"document\" transport=\"http://schemas.xmlsoap.org/soap/http\"/>
		<wsdl:operation name=\"Authenticate\">

			<soap:operation soapAction=\"https://ssl.gnuviech.info/gnuviechadmin/Authenticate\"/>
			<wsdl:input>

				<soap:body parts=\" AuthRequest\" use=\"literal\"/>
			</wsdl:input>
			<wsdl:output>

				<soap:body parts=\" AuthResponse\" use=\"literal\"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name=\"ListDomains\">
			<soap:operation soapAction=\"https://ssl.gnuviech.info/gnuviechadmin/ListDomains\"/>
			<wsdl:input>
				<soap:body parts=\" ListDomainsRequest\" use=\"literal\"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body parts=\" ListDomainsResponse\" use=\"literal\"/>
			</wsdl:output>
		</wsdl:operation>
		<wsdl:operation name=\"ListMailAliases\">
			<soap:operation soapAction=\"https://ssl.gnuviech.info/gnuviechadmin/ListMailAliases\"/>
			<wsdl:input>
				<soap:body parts=\" ListMailAliasesRequest\" use=\"literal\"/>
			</wsdl:input>
			<wsdl:output>
				<soap:body parts=\" ListMailAliasesResponse\" use=\"literal\"/>
			</wsdl:output>
		</wsdl:operation>
	</wsdl:binding>
	<wsdl:service name=\"gnuviechadmin\">
		<wsdl:port binding=\"tns:gnuviechadminSOAP\" name=\"gnuviechadminSOAP\">
			<soap:address location=\"https://ssl.gnuviech.info/gnuviechadmin\"/>
		</wsdl:port>
	</wsdl:service>
</wsdl:definitions>"""

    def __init__(self, post='/gnuviechadmin', **kw):
        ServiceSOAPBinding.__init__(self, post)


    def soap_Authenticate(self, ps):
        # input vals in request object
        args = ps.Parse( AuthRequestWrapper )

        # assign return values to response object
        class SimpleTypeWrapper(str): typecode = AuthResponseWrapper()

        # WARNING specify value eg. SimpleTypeWrapper(1)
        response = SimpleTypeWrapper()

        # Return the response
        return response

    def soap_ListDomains(self, ps):
        # input vals in request object
        args = ps.Parse( ListDomainsRequestWrapper )

        # assign return values to response object
        response = ListDomainsResponseWrapper()

        # Return the response
        return response

    def soap_ListMailAliases(self, ps):
        # input vals in request object
        args = ps.Parse( ListMailAliasesRequestWrapper )

        # assign return values to response object
        response = ListMailAliasesResponseWrapper()

        # Return the response
        return response
